'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// Generated by src/generate.js.

/**
 * Copyright 2016 Shape Security, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License")
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var SourceLocation = exports.SourceLocation = function SourceLocation(_ref) {
  var line = _ref.line;
  var column = _ref.column;
  var offset = _ref.offset;

  _classCallCheck(this, SourceLocation);

  this.type = 'SourceLocation';
  this.line = line;
  this.column = column;
  this.offset = offset;
};

var SourceSpan = exports.SourceSpan = function SourceSpan(_ref2) {
  var source = _ref2.source;
  var start = _ref2.start;
  var end = _ref2.end;

  _classCallCheck(this, SourceSpan);

  this.type = 'SourceSpan';
  this.source = source;
  this.start = start;
  this.end = end;
};

var BindingWithDefault = exports.BindingWithDefault = function BindingWithDefault(_ref3) {
  var binding = _ref3.binding;
  var init = _ref3.init;

  _classCallCheck(this, BindingWithDefault);

  this.type = 'BindingWithDefault';
  this.binding = binding;
  this.init = init;
};

var BindingIdentifier = exports.BindingIdentifier = function BindingIdentifier(_ref4) {
  var name = _ref4.name;

  _classCallCheck(this, BindingIdentifier);

  this.type = 'BindingIdentifier';
  this.name = name;
};

var ArrayBinding = exports.ArrayBinding = function ArrayBinding(_ref5) {
  var elements = _ref5.elements;
  var restElement = _ref5.restElement;

  _classCallCheck(this, ArrayBinding);

  this.type = 'ArrayBinding';
  this.elements = elements;
  this.restElement = restElement;
};

var ObjectBinding = exports.ObjectBinding = function ObjectBinding(_ref6) {
  var properties = _ref6.properties;

  _classCallCheck(this, ObjectBinding);

  this.type = 'ObjectBinding';
  this.properties = properties;
};

var BindingPropertyIdentifier = exports.BindingPropertyIdentifier = function BindingPropertyIdentifier(_ref7) {
  var binding = _ref7.binding;
  var init = _ref7.init;

  _classCallCheck(this, BindingPropertyIdentifier);

  this.type = 'BindingPropertyIdentifier';
  this.binding = binding;
  this.init = init;
};

var BindingPropertyProperty = exports.BindingPropertyProperty = function BindingPropertyProperty(_ref8) {
  var name = _ref8.name;
  var binding = _ref8.binding;

  _classCallCheck(this, BindingPropertyProperty);

  this.type = 'BindingPropertyProperty';
  this.name = name;
  this.binding = binding;
};

var ClassExpression = exports.ClassExpression = function ClassExpression(_ref9) {
  var name = _ref9.name;
  var _super = _ref9.super;
  var elements = _ref9.elements;

  _classCallCheck(this, ClassExpression);

  this.type = 'ClassExpression';
  this.name = name;
  this.super = _super;
  this.elements = elements;
};

var ClassDeclaration = exports.ClassDeclaration = function ClassDeclaration(_ref10) {
  var name = _ref10.name;
  var _super = _ref10.super;
  var elements = _ref10.elements;

  _classCallCheck(this, ClassDeclaration);

  this.type = 'ClassDeclaration';
  this.name = name;
  this.super = _super;
  this.elements = elements;
};

var ClassElement = exports.ClassElement = function ClassElement(_ref11) {
  var isStatic = _ref11.isStatic;
  var method = _ref11.method;

  _classCallCheck(this, ClassElement);

  this.type = 'ClassElement';
  this.isStatic = isStatic;
  this.method = method;
};

var Module = exports.Module = function Module(_ref12) {
  var directives = _ref12.directives;
  var items = _ref12.items;

  _classCallCheck(this, Module);

  this.type = 'Module';
  this.directives = directives;
  this.items = items;
};

var Import = exports.Import = function Import(_ref13) {
  var moduleSpecifier = _ref13.moduleSpecifier;
  var defaultBinding = _ref13.defaultBinding;
  var namedImports = _ref13.namedImports;

  _classCallCheck(this, Import);

  this.type = 'Import';
  this.moduleSpecifier = moduleSpecifier;
  this.defaultBinding = defaultBinding;
  this.namedImports = namedImports;
};

var ImportNamespace = exports.ImportNamespace = function ImportNamespace(_ref14) {
  var moduleSpecifier = _ref14.moduleSpecifier;
  var defaultBinding = _ref14.defaultBinding;
  var namespaceBinding = _ref14.namespaceBinding;

  _classCallCheck(this, ImportNamespace);

  this.type = 'ImportNamespace';
  this.moduleSpecifier = moduleSpecifier;
  this.defaultBinding = defaultBinding;
  this.namespaceBinding = namespaceBinding;
};

var ImportSpecifier = exports.ImportSpecifier = function ImportSpecifier(_ref15) {
  var name = _ref15.name;
  var binding = _ref15.binding;

  _classCallCheck(this, ImportSpecifier);

  this.type = 'ImportSpecifier';
  this.name = name;
  this.binding = binding;
};

var ExportAllFrom = exports.ExportAllFrom = function ExportAllFrom(_ref16) {
  var moduleSpecifier = _ref16.moduleSpecifier;

  _classCallCheck(this, ExportAllFrom);

  this.type = 'ExportAllFrom';
  this.moduleSpecifier = moduleSpecifier;
};

var ExportFrom = exports.ExportFrom = function ExportFrom(_ref17) {
  var namedExports = _ref17.namedExports;
  var moduleSpecifier = _ref17.moduleSpecifier;

  _classCallCheck(this, ExportFrom);

  this.type = 'ExportFrom';
  this.namedExports = namedExports;
  this.moduleSpecifier = moduleSpecifier;
};

var Export = exports.Export = function Export(_ref18) {
  var declaration = _ref18.declaration;

  _classCallCheck(this, Export);

  this.type = 'Export';
  this.declaration = declaration;
};

var ExportDefault = exports.ExportDefault = function ExportDefault(_ref19) {
  var body = _ref19.body;

  _classCallCheck(this, ExportDefault);

  this.type = 'ExportDefault';
  this.body = body;
};

var ExportSpecifier = exports.ExportSpecifier = function ExportSpecifier(_ref20) {
  var name = _ref20.name;
  var exportedName = _ref20.exportedName;

  _classCallCheck(this, ExportSpecifier);

  this.type = 'ExportSpecifier';
  this.name = name;
  this.exportedName = exportedName;
};

var Method = exports.Method = function Method(_ref21) {
  var name = _ref21.name;
  var isGenerator = _ref21.isGenerator;
  var params = _ref21.params;
  var body = _ref21.body;

  _classCallCheck(this, Method);

  this.type = 'Method';
  this.name = name;
  this.isGenerator = isGenerator;
  this.params = params;
  this.body = body;
};

var Getter = exports.Getter = function Getter(_ref22) {
  var name = _ref22.name;
  var body = _ref22.body;

  _classCallCheck(this, Getter);

  this.type = 'Getter';
  this.name = name;
  this.body = body;
};

var Setter = exports.Setter = function Setter(_ref23) {
  var name = _ref23.name;
  var param = _ref23.param;
  var body = _ref23.body;

  _classCallCheck(this, Setter);

  this.type = 'Setter';
  this.name = name;
  this.param = param;
  this.body = body;
};

var DataProperty = exports.DataProperty = function DataProperty(_ref24) {
  var name = _ref24.name;
  var expression = _ref24.expression;

  _classCallCheck(this, DataProperty);

  this.type = 'DataProperty';
  this.name = name;
  this.expression = expression;
};

var ShorthandProperty = exports.ShorthandProperty = function ShorthandProperty(_ref25) {
  var name = _ref25.name;

  _classCallCheck(this, ShorthandProperty);

  this.type = 'ShorthandProperty';
  this.name = name;
};

var ComputedPropertyName = exports.ComputedPropertyName = function ComputedPropertyName(_ref26) {
  var expression = _ref26.expression;

  _classCallCheck(this, ComputedPropertyName);

  this.type = 'ComputedPropertyName';
  this.expression = expression;
};

var StaticPropertyName = exports.StaticPropertyName = function StaticPropertyName(_ref27) {
  var value = _ref27.value;

  _classCallCheck(this, StaticPropertyName);

  this.type = 'StaticPropertyName';
  this.value = value;
};

var LiteralBooleanExpression = exports.LiteralBooleanExpression = function LiteralBooleanExpression(_ref28) {
  var value = _ref28.value;

  _classCallCheck(this, LiteralBooleanExpression);

  this.type = 'LiteralBooleanExpression';
  this.value = value;
};

var LiteralInfinityExpression = exports.LiteralInfinityExpression = function LiteralInfinityExpression() {
  _classCallCheck(this, LiteralInfinityExpression);

  this.type = 'LiteralInfinityExpression';
};

var LiteralNullExpression = exports.LiteralNullExpression = function LiteralNullExpression() {
  _classCallCheck(this, LiteralNullExpression);

  this.type = 'LiteralNullExpression';
};

var LiteralNumericExpression = exports.LiteralNumericExpression = function LiteralNumericExpression(_ref29) {
  var value = _ref29.value;

  _classCallCheck(this, LiteralNumericExpression);

  this.type = 'LiteralNumericExpression';
  this.value = value;
};

var LiteralRegExpExpression = exports.LiteralRegExpExpression = function LiteralRegExpExpression(_ref30) {
  var pattern = _ref30.pattern;
  var flags = _ref30.flags;

  _classCallCheck(this, LiteralRegExpExpression);

  this.type = 'LiteralRegExpExpression';
  this.pattern = pattern;
  this.flags = flags;
};

var LiteralStringExpression = exports.LiteralStringExpression = function LiteralStringExpression(_ref31) {
  var value = _ref31.value;

  _classCallCheck(this, LiteralStringExpression);

  this.type = 'LiteralStringExpression';
  this.value = value;
};

var ArrayExpression = exports.ArrayExpression = function ArrayExpression(_ref32) {
  var elements = _ref32.elements;

  _classCallCheck(this, ArrayExpression);

  this.type = 'ArrayExpression';
  this.elements = elements;
};

var ArrowExpression = exports.ArrowExpression = function ArrowExpression(_ref33) {
  var params = _ref33.params;
  var body = _ref33.body;

  _classCallCheck(this, ArrowExpression);

  this.type = 'ArrowExpression';
  this.params = params;
  this.body = body;
};

var AssignmentExpression = exports.AssignmentExpression = function AssignmentExpression(_ref34) {
  var binding = _ref34.binding;
  var expression = _ref34.expression;

  _classCallCheck(this, AssignmentExpression);

  this.type = 'AssignmentExpression';
  this.binding = binding;
  this.expression = expression;
};

var BinaryExpression = exports.BinaryExpression = function BinaryExpression(_ref35) {
  var operator = _ref35.operator;
  var left = _ref35.left;
  var right = _ref35.right;

  _classCallCheck(this, BinaryExpression);

  this.type = 'BinaryExpression';
  this.operator = operator;
  this.left = left;
  this.right = right;
};

var CallExpression = exports.CallExpression = function CallExpression(_ref36) {
  var callee = _ref36.callee;
  var _arguments = _ref36.arguments;

  _classCallCheck(this, CallExpression);

  this.type = 'CallExpression';
  this.callee = callee;
  this.arguments = _arguments;
};

var CompoundAssignmentExpression = exports.CompoundAssignmentExpression = function CompoundAssignmentExpression(_ref37) {
  var operator = _ref37.operator;
  var binding = _ref37.binding;
  var expression = _ref37.expression;

  _classCallCheck(this, CompoundAssignmentExpression);

  this.type = 'CompoundAssignmentExpression';
  this.operator = operator;
  this.binding = binding;
  this.expression = expression;
};

var ComputedMemberExpression = exports.ComputedMemberExpression = function ComputedMemberExpression(_ref38) {
  var object = _ref38.object;
  var expression = _ref38.expression;

  _classCallCheck(this, ComputedMemberExpression);

  this.type = 'ComputedMemberExpression';
  this.object = object;
  this.expression = expression;
};

var ConditionalExpression = exports.ConditionalExpression = function ConditionalExpression(_ref39) {
  var test = _ref39.test;
  var consequent = _ref39.consequent;
  var alternate = _ref39.alternate;

  _classCallCheck(this, ConditionalExpression);

  this.type = 'ConditionalExpression';
  this.test = test;
  this.consequent = consequent;
  this.alternate = alternate;
};

var FunctionExpression = exports.FunctionExpression = function FunctionExpression(_ref40) {
  var isGenerator = _ref40.isGenerator;
  var name = _ref40.name;
  var params = _ref40.params;
  var body = _ref40.body;

  _classCallCheck(this, FunctionExpression);

  this.type = 'FunctionExpression';
  this.isGenerator = isGenerator;
  this.name = name;
  this.params = params;
  this.body = body;
};

var IdentifierExpression = exports.IdentifierExpression = function IdentifierExpression(_ref41) {
  var name = _ref41.name;

  _classCallCheck(this, IdentifierExpression);

  this.type = 'IdentifierExpression';
  this.name = name;
};

var NewExpression = exports.NewExpression = function NewExpression(_ref42) {
  var callee = _ref42.callee;
  var _arguments = _ref42.arguments;

  _classCallCheck(this, NewExpression);

  this.type = 'NewExpression';
  this.callee = callee;
  this.arguments = _arguments;
};

var NewTargetExpression = exports.NewTargetExpression = function NewTargetExpression() {
  _classCallCheck(this, NewTargetExpression);

  this.type = 'NewTargetExpression';
};

var ObjectExpression = exports.ObjectExpression = function ObjectExpression(_ref43) {
  var properties = _ref43.properties;

  _classCallCheck(this, ObjectExpression);

  this.type = 'ObjectExpression';
  this.properties = properties;
};

var UnaryExpression = exports.UnaryExpression = function UnaryExpression(_ref44) {
  var operator = _ref44.operator;
  var operand = _ref44.operand;

  _classCallCheck(this, UnaryExpression);

  this.type = 'UnaryExpression';
  this.operator = operator;
  this.operand = operand;
};

var StaticMemberExpression = exports.StaticMemberExpression = function StaticMemberExpression(_ref45) {
  var object = _ref45.object;
  var property = _ref45.property;

  _classCallCheck(this, StaticMemberExpression);

  this.type = 'StaticMemberExpression';
  this.object = object;
  this.property = property;
};

var TemplateExpression = exports.TemplateExpression = function TemplateExpression(_ref46) {
  var tag = _ref46.tag;
  var elements = _ref46.elements;

  _classCallCheck(this, TemplateExpression);

  this.type = 'TemplateExpression';
  this.tag = tag;
  this.elements = elements;
};

var ThisExpression = exports.ThisExpression = function ThisExpression() {
  _classCallCheck(this, ThisExpression);

  this.type = 'ThisExpression';
};

var UpdateExpression = exports.UpdateExpression = function UpdateExpression(_ref47) {
  var isPrefix = _ref47.isPrefix;
  var operator = _ref47.operator;
  var operand = _ref47.operand;

  _classCallCheck(this, UpdateExpression);

  this.type = 'UpdateExpression';
  this.isPrefix = isPrefix;
  this.operator = operator;
  this.operand = operand;
};

var YieldExpression = exports.YieldExpression = function YieldExpression(_ref48) {
  var expression = _ref48.expression;

  _classCallCheck(this, YieldExpression);

  this.type = 'YieldExpression';
  this.expression = expression;
};

var YieldGeneratorExpression = exports.YieldGeneratorExpression = function YieldGeneratorExpression(_ref49) {
  var expression = _ref49.expression;

  _classCallCheck(this, YieldGeneratorExpression);

  this.type = 'YieldGeneratorExpression';
  this.expression = expression;
};

var BlockStatement = exports.BlockStatement = function BlockStatement(_ref50) {
  var block = _ref50.block;

  _classCallCheck(this, BlockStatement);

  this.type = 'BlockStatement';
  this.block = block;
};

var BreakStatement = exports.BreakStatement = function BreakStatement(_ref51) {
  var label = _ref51.label;

  _classCallCheck(this, BreakStatement);

  this.type = 'BreakStatement';
  this.label = label;
};

var ContinueStatement = exports.ContinueStatement = function ContinueStatement(_ref52) {
  var label = _ref52.label;

  _classCallCheck(this, ContinueStatement);

  this.type = 'ContinueStatement';
  this.label = label;
};

var DebuggerStatement = exports.DebuggerStatement = function DebuggerStatement() {
  _classCallCheck(this, DebuggerStatement);

  this.type = 'DebuggerStatement';
};

var DoWhileStatement = exports.DoWhileStatement = function DoWhileStatement(_ref53) {
  var body = _ref53.body;
  var test = _ref53.test;

  _classCallCheck(this, DoWhileStatement);

  this.type = 'DoWhileStatement';
  this.body = body;
  this.test = test;
};

var EmptyStatement = exports.EmptyStatement = function EmptyStatement() {
  _classCallCheck(this, EmptyStatement);

  this.type = 'EmptyStatement';
};

var ExpressionStatement = exports.ExpressionStatement = function ExpressionStatement(_ref54) {
  var expression = _ref54.expression;

  _classCallCheck(this, ExpressionStatement);

  this.type = 'ExpressionStatement';
  this.expression = expression;
};

var ForInStatement = exports.ForInStatement = function ForInStatement(_ref55) {
  var left = _ref55.left;
  var right = _ref55.right;
  var body = _ref55.body;

  _classCallCheck(this, ForInStatement);

  this.type = 'ForInStatement';
  this.left = left;
  this.right = right;
  this.body = body;
};

var ForOfStatement = exports.ForOfStatement = function ForOfStatement(_ref56) {
  var left = _ref56.left;
  var right = _ref56.right;
  var body = _ref56.body;

  _classCallCheck(this, ForOfStatement);

  this.type = 'ForOfStatement';
  this.left = left;
  this.right = right;
  this.body = body;
};

var ForStatement = exports.ForStatement = function ForStatement(_ref57) {
  var init = _ref57.init;
  var test = _ref57.test;
  var update = _ref57.update;
  var body = _ref57.body;

  _classCallCheck(this, ForStatement);

  this.type = 'ForStatement';
  this.init = init;
  this.test = test;
  this.update = update;
  this.body = body;
};

var IfStatement = exports.IfStatement = function IfStatement(_ref58) {
  var test = _ref58.test;
  var consequent = _ref58.consequent;
  var alternate = _ref58.alternate;

  _classCallCheck(this, IfStatement);

  this.type = 'IfStatement';
  this.test = test;
  this.consequent = consequent;
  this.alternate = alternate;
};

var LabeledStatement = exports.LabeledStatement = function LabeledStatement(_ref59) {
  var label = _ref59.label;
  var body = _ref59.body;

  _classCallCheck(this, LabeledStatement);

  this.type = 'LabeledStatement';
  this.label = label;
  this.body = body;
};

var ReturnStatement = exports.ReturnStatement = function ReturnStatement(_ref60) {
  var expression = _ref60.expression;

  _classCallCheck(this, ReturnStatement);

  this.type = 'ReturnStatement';
  this.expression = expression;
};

var SwitchStatement = exports.SwitchStatement = function SwitchStatement(_ref61) {
  var discriminant = _ref61.discriminant;
  var cases = _ref61.cases;

  _classCallCheck(this, SwitchStatement);

  this.type = 'SwitchStatement';
  this.discriminant = discriminant;
  this.cases = cases;
};

var SwitchStatementWithDefault = exports.SwitchStatementWithDefault = function SwitchStatementWithDefault(_ref62) {
  var discriminant = _ref62.discriminant;
  var preDefaultCases = _ref62.preDefaultCases;
  var defaultCase = _ref62.defaultCase;
  var postDefaultCases = _ref62.postDefaultCases;

  _classCallCheck(this, SwitchStatementWithDefault);

  this.type = 'SwitchStatementWithDefault';
  this.discriminant = discriminant;
  this.preDefaultCases = preDefaultCases;
  this.defaultCase = defaultCase;
  this.postDefaultCases = postDefaultCases;
};

var ThrowStatement = exports.ThrowStatement = function ThrowStatement(_ref63) {
  var expression = _ref63.expression;

  _classCallCheck(this, ThrowStatement);

  this.type = 'ThrowStatement';
  this.expression = expression;
};

var TryCatchStatement = exports.TryCatchStatement = function TryCatchStatement(_ref64) {
  var body = _ref64.body;
  var catchClause = _ref64.catchClause;

  _classCallCheck(this, TryCatchStatement);

  this.type = 'TryCatchStatement';
  this.body = body;
  this.catchClause = catchClause;
};

var TryFinallyStatement = exports.TryFinallyStatement = function TryFinallyStatement(_ref65) {
  var body = _ref65.body;
  var catchClause = _ref65.catchClause;
  var finalizer = _ref65.finalizer;

  _classCallCheck(this, TryFinallyStatement);

  this.type = 'TryFinallyStatement';
  this.body = body;
  this.catchClause = catchClause;
  this.finalizer = finalizer;
};

var VariableDeclarationStatement = exports.VariableDeclarationStatement = function VariableDeclarationStatement(_ref66) {
  var declaration = _ref66.declaration;

  _classCallCheck(this, VariableDeclarationStatement);

  this.type = 'VariableDeclarationStatement';
  this.declaration = declaration;
};

var WhileStatement = exports.WhileStatement = function WhileStatement(_ref67) {
  var test = _ref67.test;
  var body = _ref67.body;

  _classCallCheck(this, WhileStatement);

  this.type = 'WhileStatement';
  this.test = test;
  this.body = body;
};

var WithStatement = exports.WithStatement = function WithStatement(_ref68) {
  var object = _ref68.object;
  var body = _ref68.body;

  _classCallCheck(this, WithStatement);

  this.type = 'WithStatement';
  this.object = object;
  this.body = body;
};

var Block = exports.Block = function Block(_ref69) {
  var statements = _ref69.statements;

  _classCallCheck(this, Block);

  this.type = 'Block';
  this.statements = statements;
};

var CatchClause = exports.CatchClause = function CatchClause(_ref70) {
  var binding = _ref70.binding;
  var body = _ref70.body;

  _classCallCheck(this, CatchClause);

  this.type = 'CatchClause';
  this.binding = binding;
  this.body = body;
};

var Directive = exports.Directive = function Directive(_ref71) {
  var rawValue = _ref71.rawValue;

  _classCallCheck(this, Directive);

  this.type = 'Directive';
  this.rawValue = rawValue;
};

var FormalParameters = exports.FormalParameters = function FormalParameters(_ref72) {
  var items = _ref72.items;
  var rest = _ref72.rest;

  _classCallCheck(this, FormalParameters);

  this.type = 'FormalParameters';
  this.items = items;
  this.rest = rest;
};

var FunctionBody = exports.FunctionBody = function FunctionBody(_ref73) {
  var directives = _ref73.directives;
  var statements = _ref73.statements;

  _classCallCheck(this, FunctionBody);

  this.type = 'FunctionBody';
  this.directives = directives;
  this.statements = statements;
};

var FunctionDeclaration = exports.FunctionDeclaration = function FunctionDeclaration(_ref74) {
  var isGenerator = _ref74.isGenerator;
  var name = _ref74.name;
  var params = _ref74.params;
  var body = _ref74.body;

  _classCallCheck(this, FunctionDeclaration);

  this.type = 'FunctionDeclaration';
  this.isGenerator = isGenerator;
  this.name = name;
  this.params = params;
  this.body = body;
};

var Script = exports.Script = function Script(_ref75) {
  var directives = _ref75.directives;
  var statements = _ref75.statements;

  _classCallCheck(this, Script);

  this.type = 'Script';
  this.directives = directives;
  this.statements = statements;
};

var SpreadElement = exports.SpreadElement = function SpreadElement(_ref76) {
  var expression = _ref76.expression;

  _classCallCheck(this, SpreadElement);

  this.type = 'SpreadElement';
  this.expression = expression;
};

var Super = exports.Super = function Super() {
  _classCallCheck(this, Super);

  this.type = 'Super';
};

var SwitchCase = exports.SwitchCase = function SwitchCase(_ref77) {
  var test = _ref77.test;
  var consequent = _ref77.consequent;

  _classCallCheck(this, SwitchCase);

  this.type = 'SwitchCase';
  this.test = test;
  this.consequent = consequent;
};

var SwitchDefault = exports.SwitchDefault = function SwitchDefault(_ref78) {
  var consequent = _ref78.consequent;

  _classCallCheck(this, SwitchDefault);

  this.type = 'SwitchDefault';
  this.consequent = consequent;
};

var TemplateElement = exports.TemplateElement = function TemplateElement(_ref79) {
  var rawValue = _ref79.rawValue;

  _classCallCheck(this, TemplateElement);

  this.type = 'TemplateElement';
  this.rawValue = rawValue;
};

var VariableDeclaration = exports.VariableDeclaration = function VariableDeclaration(_ref80) {
  var kind = _ref80.kind;
  var declarators = _ref80.declarators;

  _classCallCheck(this, VariableDeclaration);

  this.type = 'VariableDeclaration';
  this.kind = kind;
  this.declarators = declarators;
};

var VariableDeclarator = exports.VariableDeclarator = function VariableDeclarator(_ref81) {
  var binding = _ref81.binding;
  var init = _ref81.init;

  _classCallCheck(this, VariableDeclarator);

  this.type = 'VariableDeclarator';
  this.binding = binding;
  this.init = init;
};